const ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
const z = new ZeedhiAPIConstructor(browser, protractor);
const Helper = require('teknisa-helper');
const geral = new Helper.geral();
const loginPage = new Helper.login();
const protractorHelper = require('protractor-helper');
const j = require('../../../../../json/leitorJson.po.js');
const quadroSocietarios = require('../../../../../page-objects/parametrizacao/contabil/ecf/bloco y/quadrosSocietarios.po.js');
const quadroSocGridId = '166664978023033900162638';

describe('Tela Quadro Societários e Rendimentos', () => {
	beforeAll(() => {
		loginPage.login(j.getValor('login'), j.getValor('senha'));
		quadroSocietarios.abrir();
		z.component.footer.clickRightActionByLabel('Filtrar', true);
		protractorHelper.waitForElementVisibility(element(by.id(`grid-${quadroSocGridId}`)));
	});

	afterAll(() => {
		geral.sair();
	});

	it('Deve acessar a tela Quadro Societários e Rendimentos', () => {
		expect(z.component.header.getTitle()).toBe('Quadro Societários e Rendimentos');
	});

	it('Deve adicionar um registro', () => {
		geral.clickAdicionar();
		quadroSocietarios.adicionar(j.getValor('nomeQuadro'), j.getValor('pais'),
			j.getValor('tipoPessoa'), j.getValor('cpf'), j.getValor('socio'),
			j.getValor('cpf1'), j.getValor('qualificacaoRepresentante'));
		geral.clickSalvar();
		geral.clickOk();
		geral.filterIt(j.getValor('nomeQuadro'));

		expect(geral.gridHasText(quadroSocGridId, j.getValor('nomeQuadro')))
			.toBe(j.getValor('nomeQuadro'));
	});

	it('Adicioanar registro a aba Quadros Societários', () => {
		geral.clickGrid('NMREG', j.getValor('nomeQuadro'), quadroSocGridId);
		geral.trocarAba('Quadros Societários');
		geral.clickAdicionar();
		quadroSocietarios.adicionarQuadro(j.getValor('unidade'), j.getValor('relacaoEmpresa'),
			j.getValor('dataAlteracao'), j.getValor('dataFinal'),
			j.getValor('porcentagemCapitalTotal'), j.getValor('porcentagemCapitalVotante'));
		geral.clickSalvar();
		protractorHelper.waitForElementVisibility(element(by.id('grid-166664978017821019252639')));

		expect(geral.gridHasText('166664978017821019252639', j.getValor('nomeQuadro1')))
			.toBe(j.getValor('nomeQuadro1'));
	});

	it('Adicioanar registro a aba Rendimentos', () => {
		geral.trocarAba('Rendimentos');
		geral.clickAdicionar();
		quadroSocietarios.adicionarRendimentos(j.getValor('unidade'), j.getValor('anoRef'),
			j.getValor('origemRendimento'), j.getValor('remuneracaoTrabalho'),
			j.getValor('lucro'), j.getValor('juros'), j.getValor('demaisRendimentos'),
			j.getValor('ValorIR'));
		geral.clickSalvar();
		protractorHelper.waitForElementVisibility(element(by.id('grid-166664978037031097812660')));

		expect(geral.gridHasText('166664978037031097812660', j.getValor('nomeQuadro1')))
			.toBe(j.getValor('nomeQuadro1'));
	});

	it('Adicioanar registro a aba Empresas', () => {
		geral.trocarAba('Empresas');
		geral.clickAdicionar();
		quadroSocietarios.adicionarEmpresas(j.getValor('unidade'), j.getValor('qualificacaoEmpresa'),
			j.getValor('dataAlteracao'), j.getValor('dataFinal'), j.getValor('porcentagemTotal'),
			j.getValor('porcentagemVotante'));
		geral.clickSalvar();
		protractorHelper.waitForElementVisibility(element(by.id('grid-16666497803663281711727')));

		expect(geral.gridHasText('16666497803663281711727', j.getValor('nomeQuadro1')))
			.toBe(j.getValor('nomeQuadro1'));
	});

	it('Deve editar o formulário adicionado', () => {
		geral.trocarAba('Formulário');
		geral.clickEditar();
		quadroSocietarios.editar(j.getValor('nomeQuadro1'), j.getValor('pais1'),
			j.getValor('tipoPessoa1'), j.getValor('cpf2'), j.getValor('socio1'),
			j.getValor('qualificacaoRepresentante1'));
		geral.clickSalvar();
		protractorHelper.waitForElementVisibility(element(by.id(`grid-${quadroSocGridId}`)));

		expect(geral.gridHasText(quadroSocGridId, j.getValor('nomeQuadro')))
			.toBe(j.getValor('nomeQuadro'));
		geral.clickVoltar();
	});

	it('Excluir registro', () => {
		geral.clickGrid('NMREG', j.getValor('nomeQuadro1'), quadroSocGridId);
		geral.clickExcluir();
		geral.clickSim();
		geral.filterIt(j.getValor('nomeQuadro1'));
		protractorHelper.waitForElementVisibility(element(by.id(`grid-${quadroSocGridId}`)));

		expect(geral.gridHasText(quadroSocGridId, j.getValor('nomeQuadro1')))
			.toBeUndefined();
	});
});
